This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 506453 (CVE-2009-1687)

Summary: CVE-2009-1687 kdelibs: Integer overflow in KJS JavaScript garbage collector
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: urgent Docs Contact:
Priority: urgent    
Version: unspecifiedCC: bressers, jreznik, kevin, security-response-team, than
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
URL: http://trac.webkit.org/changeset/41854
Whiteboard: public=20090625,reported=20090610,source=cve,impact=critical,cvss2=6.8/AV:N/AC:M/Au:N/C:P/I:P/A:P,cwe=CWE-190[auto]
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-04-11 16:58:43 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 505619, 505620, 505621, 505622, 833918    
Bug Blocks:    
Attachments:
Description Flags
Untested patch against kdelibs 4.2.98 none

Description Jan Lieskovsky 2009-06-17 08:22:31 EDT
An integer overflow, leading to heap-based buffer overflow was found
in the KDE implementation of garbage collector for the JavaScript 
language (KJS). An remote attacker could use this flaw to cause a denial
of service (konqueror crash), or potentially, execute arbitrary code with
the privileges of the user running "konqueror" web browser, if the
victim visited a specially-crafted HTML page.

References:
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2009-1687
http://support.apple.com/kb/HT3613

Upstream WebKit patch:
http://trac.webkit.org/changeset/41854

Reproducer:
No reproducer available.
Comment 1 Jan Lieskovsky 2009-06-17 08:23:38 EDT
This issue does NOT affect the version of the kdelibs package, as shipped
with Red Hat Enterprise Linux 3.

This issue affects the versions of the kdelibs package, as shipped 
with Red Hat Enterprise Linux 4 and 5.
Comment 7 errata-xmlrpc 2009-06-25 12:42:08 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 4
  Red Hat Enterprise Linux 5

Via RHSA-2009:1127 https://rhn.redhat.com/errata/RHSA-2009-1127.html
Comment 8 Kevin Kofler 2009-07-25 18:47:37 EDT
This also affects kdelibs3 3.5.10 and appears to affect kdelibs 4.2.4 in Fedora.
Comment 9 Kevin Kofler 2009-07-25 19:11:31 EDT
(Note that this is NOT fixed in KDE trunk.)
Comment 10 Kevin Kofler 2009-07-25 20:07:32 EDT
For QtWebKit, this is fixed in Qt 4.5.2 which got pushed to Fedora updates recently. I didn't check earlier versions.
Comment 11 Kevin Kofler 2009-07-25 22:01:25 EDT
Unfortunately, the WebKit patch, while fixing the integer overflow, still allows DoSing the browser, it just aborts if it would overflow. :-(
Comment 12 Kevin Kofler 2009-07-25 22:10:21 EDT
Created attachment 355170 [details]
Untested patch against kdelibs 4.2.98

Here's an untested patch against kdelibs 4.2.98. Like the WebKit patch, this just crashes if we would overflow. IMHO, doing things right would mean throwing an error somehow, but I don't understand the code well enough to do that.
Comment 13 Fedora Update System 2009-07-26 04:29:18 EDT
kdelibs-4.2.4-6.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/kdelibs-4.2.4-6.fc11
Comment 14 Fedora Update System 2009-07-26 04:30:50 EDT
kdelibs-4.2.4-6.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/kdelibs-4.2.4-6.fc10
Comment 15 Fedora Update System 2009-07-26 04:35:05 EDT
kdelibs3-3.5.10-13.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/kdelibs3-3.5.10-13.fc11
Comment 16 Fedora Update System 2009-07-26 04:45:08 EDT
kdelibs3-3.5.10-13.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/kdelibs3-3.5.10-13.fc10
Comment 17 Fedora Update System 2009-07-28 14:23:00 EDT
kdelibs-4.2.4-6.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 18 Fedora Update System 2009-07-28 14:26:30 EDT
kdelibs-4.2.4-6.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2009-07-28 14:27:17 EDT
kdelibs3-3.5.10-13.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2009-07-28 14:27:54 EDT
kdelibs3-3.5.10-13.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.